#include "student.hpp"
#include <sstream>
#include <iostream>

using std::string;

Student::Student(std::string vorname, std::string nachname, int matnr) : Person(vorname, nachname), matnr(matnr), thesis(NULL) {
}

Student::Student(const Student& s) : Person(s), matnr(s.matnr), thesis(new Thesis(*s.thesis)) {
	std::cout << "Kopierkonstruktor von Student" << std::endl;
}

Student& Student::operator=(const Student& s){
	if (this == &s) {
		return *this;
	}

	this->Person::operator=(s);
	
	this->matnr = s.matnr;
	delete thesis;
	this->thesis = new Thesis(*s.thesis);
	
	return *this;
}

Student::~Student() {
	std::cout << "Destruktor von Student" << std::endl;
	delete thesis;
}

string Student::toString() const {
	std::stringstream strstr;
	strstr << vorname << " " << nachname << " (" << matnr << ")";
	return strstr.str();
}

void Student::setThesis(Thesis* thesis){
	this->thesis = thesis;
}

void Student::work() {
	std::cout << "Student studiert" << std::endl;
}
